﻿local L = LibStub("AceLocale-3.0"):GetLocale("AffDots")
local ElvAPI

local dmg_buff = 1
local protect = 0
local rip_protect = 0
local lastspdcof = 1
local pitofcof = 1
local damageboncof = 1
local o
local crit_s = ""
local crit_h = ""
local me, spec
local timer, throttle		= 0, 0.1
local dot_damage, targets	= AffDots.dot_damage, AffDots.targets
local dot_damage_ext = { }
local saGUID = { }
local durSaved = { }
local dot_tiks = { }
local MindBlastFrame

local is50300 = true

if select(4, GetBuildInfo()) >= 50400 then
	is50300 = false
end


--Locale 

L["Shadow"] = "Shadow"
L["Change SWP and VT postition"] = "Change SWP and VT postition"
L["Turn Off 2p15"] = "Turn Off 2p15"
L["VT"] = "Vampiric Touch"
L["SWP"] = "Shadow Word:Pain"
L["DP"] = "Devouring Plague"
L["ORBS"] = "Shadow Orbs"
L["Show Shadow Word:Pain"] = "Show Shadow Word:Pain"
L["Show Vampiric Touch"] = "Show Vampiric Touch"
L["Show Devouring Plague"] = "Show Devouring Plague"
L["Show Shadow Orbs"] = "Show Shadow Orbs"
L["Update all scales when exteded (for 5.2)"] = "Update all scales when exteded (for 5.2)"
L["Enable Debug"] = "Enable Debug"
L["Show Shadow Word:Death"] = "Show Shadow Word:Death"
L["SWD"] = "Shadow Word:Death"
L["Colors for Shadow Word:Death"] = "Colors for Shadow Word:Death"
L["Can be used"] = "Can be used"
L["ICD"] = "ICD"
L["CD"] = "CD"
L["Show normal dot ticks"] = "Show normal dot ticks"
L["UVLS main prioriry"] = "UVLS main prioriry"
L["Integrate dot colors in ElvUI"] = "Integrate dot colors in ElvUI"
L["Show Mind Blast"] = "Show Mind Blast"
L["Mind Blast"] = "Mind Blast"
L["shadowdesc"] = "If you want dots to show in certain order in TidyPlates, go to 'Tidy Plates Hub: Tank' and 'Tidy Plates Hub: Damage', find 'Buffs & Debuffs' section, set 'Filter Mode' to 'Specific Auras' and write this in Aura List:\nMy 589\nMy 34914\nAll 1490\nFirst line is SWP, second is VT, last CoE. Reorder them as needed. Put other auras in list if you need them"
L["Current stats are better"] = "Current stats are better"
L["Current stats are same"] = "Current stats are same"
L["Current stats are worse"] = "Current stats are worse"
L["Mind Flay Bar color"] = "Mind Flay Bar color"
L["Current stats are better, but not optimal for update. Used by floating threshold"] = "Current stats are better, but not optimal for update. Used by floating threshold"
L["Switch color only if current stats are at least x% better"] = "Switch color only if current stats are at least x% better"
L["Mind Flay"] = "Mind Flay"
L["Show Mind Flay"] = "Show Mind Flay"
L["Dot tick count from new line"] = "Dot tick count from new line"


local function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= throttle then
		for k,v in pairs(AffDots.track) do
		   AffDots.track[k].update(AffDots.track[k])
		   AffDots:FrameDraw(AffDots.track[k])
		end
	if o.tidyplates.enable and TidyPlates then AffDots:Tidy() end
	if o.elvui and ElvUI and ElvUI[1].NamePlates and ElvUI[1].NamePlates.enabledState then AffDots:ElvNP() end
	timer = 0
    end
end

local function Round(num) return math.floor(num+.5) end
local function SecondsRound(num)
	if num > 20 then return math.floor(num+.5)
	else return format(" %.1f ", math.floor(num*10+.5)/10) end
end

local set2t15 = false
local t15set = {
        96674,96675,96676,96677,96678,
        95300,95301,95302,95303,95304,
        95930,95931,95932,95933,95934,
    }
	
function AffDots:Detect2T15()
    set2t15 = false
    local t15items = 0
    for i,v in ipairs(t15set) do
        if IsEquippedItem(v) then
            t15items = t15items + 1
        end
    end
    if t15items >= 2 then set2t15 = true end
--	print("CHECK 2t15:",set2t15)
end

local spells = {
	swp				= GetSpellInfo(589), 	--SWP
	vt				= GetSpellInfo(34914),	--VT
	fluidity		= GetSpellInfo(138002), --Fluidity +40%
	nutriment		= GetSpellInfo(140741), --Primal Nutriment +100% +10% per stack
	tricks			= GetSpellInfo(57934),	--Tricks of the Trade + 15%
	fearless		= GetSpellInfo(118977), --Fearless + 60%
	LMG				= GetSpellInfo(137590), -- LMG
	shadowform		= GetSpellInfo(15473),
	powerinfusion   = GetSpellInfo(10060), --power infusiom
	twistoffitg     = GetSpellInfo(123254),
	skullbanner		= GetSpellInfo(114207),
	uvls			= GetSpellInfo(138963),
	power_titans	= GetSpellInfo(144364),
	mf 				= GetSpellInfo(15407),
	insanity 		= GetSpellInfo(129197),
		
--	test			= GetSpellInfo(119050), --test
}

local mf_icon 			= select(3, GetSpellInfo(15407))
local insanity_icon  	= select(3, GetSpellInfo(129197))



local swp_vt = {
	[589] = GetSpellInfo(589),
	[34914] = GetSpellInfo(34914),
}


local function GetDmgBuffsUpdate()
	dmg_buff = 1
	
	local fluidity 			= UnitAura("player",	spells.fluidity, nil, "HARMFUL")
	local _,_,_,nutriment 	= UnitAura("player",   spells.nutriment)
	local tricks 			= UnitAura("player",	  spells.tricks)
	local fearless 			= UnitAura("player",	spells.fearless)
	local shadowform		= UnitAura("player",	spells.shadowform)
	local pi				= UnitAura("player",	spells.powerinfusion)
	local tof				= UnitAura("player",	spells.twistoffitg)
	local skullbanner		= UnitAura("player",	spells.skullbanner)
	local power_titans		= UnitAura("player",	spells.power_titans)
	
	if fluidity 	then dmg_buff = dmg_buff * 1.4 			end
	if nutriment 	then dmg_buff = 2 + (nutriment-1)*0.1 	end
	if fearless 	then dmg_buff = dmg_buff * 1.6 			end
	if tricks 		then dmg_buff = dmg_buff * 1.15			end
	if power_titans then dmg_buff = dmg_buff * 1.15			end
	
	if GetSpellCritChance(6) >= 100 then
		if skullbanner then dmg_buff = dmg_buff*1.20		end
	end
	
	if pi			then dmg_buff = dmg_buff * 1.05			end
	if tof			then dmg_buff = dmg_buff * 1.15			end
	if shadowform	then dmg_buff = dmg_buff * 1.25			end
	return dmg_buff
end

function AffDots:FindColor(GUID,time_left,spell,pandemic)
    if not targets[GUID..spell] or not dot_damage[spell] then
        return 7
    end
    local color = 2
    local current   = dot_damage[spell][1]
    local on_target    = targets[GUID..spell][1]
	local update 	= 0
	local update_1 	= 0
	local coefficient = 0
	local tiks_swp = 0
	if o.shadow.help_dots and ( spell == 34914 or spell == 589 ) then
		if on_target < current then

			if spell == 589 then
				local spd_1 = GetSpellBonusDamage(6)
				local mf_d = (3147+spd_1*1.5)
				tiks_swp = dot_damage[spell][4]  -- targets[GUID..spell][5]
				local swp_d = dot_damage[spell][6]		
			--	local dim = targets[GUID..spell][7]		
			--	local arg1 = 2*targets[GUID..spell][3]
			--	local swp_arg1 = 36*(tiks_swp-dim)*swp_d

			--	update = swp_arg1/(36*swp_d+swp_arg1-(time_left)*mf_d)				
			--	update_1 = swp_arg1/(36*swp_d+swp_arg1-(arg1)*mf_d)
			
				swp_arg1 = 36*(tiks_swp)*swp_d

				update = swp_arg1/(36*swp_d+swp_arg1-(time_left-1)*mf_d)   
				
			elseif spell == 34914 then
				local spd_1 = GetSpellBonusDamage(6)
				local mf_d = (3147+spd_1*1.5)
				local tiks_vt = dot_damage[spell][4] -- targets[GUID..spell][5]
				local vt_d = dot_damage[spell][6]	
				
				--coefficient = 
			--	local arg1 = targets[GUID..spell][3]
				local vt_arg1 = (-30*(tiks_vt)*vt_d)

				update = vt_arg1/(((time_left-2)*mf_d)+vt_arg1)    		
			--	update_1 = vt_arg1/((arg1*mf_d)+vt_arg1)

			end
			
			local arg2 = update
		--	print((current/on_target), arg2, tiks_swp, time_left)
			if ((current/on_target) > (arg2)) then color = 1
			elseif ((current/on_target) < (arg2)) then color = 4
			end
		elseif  on_target  > current then color = 6
		end
	else
		if      on_target*o.color_switch  < current then color = 1
		elseif  on_target  > current then color = 6
		end
	end
    return color
end

local getorb = false
local whengetorb = 0

local function GetSWDtargetHP()
	if UnitExists("target") and UnitCanAttack("player", "target")then
		local curhp = ((UnitHealth("target") * 100)/ UnitHealthMax("target"))
		
		if curhp <= 20 and curhp >0 then
			return true
		end
		return false
	end
	return false
end

local function GetDotTicks(spellID, destGUID)	
	if dot_tiks[destGUID..spellID] and dot_tiks[destGUID..spellID] == 0 then
		return true, dot_tiks[destGUID..spellID]
	else
		return false, dot_tiks[destGUID..spellID]
	end
end

local function RemoveDotTic(spellID, destGUID)
	if dot_tiks[destGUID..spellID] and dot_tiks[destGUID..spellID] > 0 then
		dot_tiks[destGUID..spellID] = dot_tiks[destGUID..spellID] - 1
	end
end

AffDots.Update = {
	dot	= function(f)
		local guid = UnitGUID(f.target)
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target,f.name,f.rank,"player")
		if duration and guid and targets[guid..f.spell] then
			if(math.abs(expires-f.timer)>1) then
				f.datanew.expires = expires
				f.datanew.duration = duration
				f.datanew.setcd = true
				f.timer = expires
			end
			f.datanew.color = o["color"..AffDots:FindColor(guid,expires - GetTime(),f.spell,f.pandemic)]
			f.datanew.tick = targets[guid..f.spell][3]
			f.datanew.t2 = SecondsRound(f.timer-GetTime())
			local gap = o.shadow.gap and "\n" or ""
			
			if o.reltext then
				if o.shadow.showticknumber and f.spell ~= 2944 then
					f.datanew.t1 = Round(dot_damage[f.spell][1]*100/targets[guid..f.spell][1])..targets[guid..f.spell][4]..gap.."("..select(2, GetDotTicks(f.spell, guid))..")"
				else
					if f.spell == 2944 then
						f.datanew.t1 = targets[guid..f.spell][4]
					else
						f.datanew.t1 = Round(dot_damage[f.spell][1]*100/targets[guid..f.spell][1])..targets[guid..f.spell][4]
					end
				end
			elseif o.layout == "bars" then
				if o.shadow.showticknumber and f.spell ~= 2944 then
					f.datanew.t1 = dot_damage[f.spell][1].."/"..targets[guid..f.spell][1]..targets[guid..f.spell][4].."("..select(2, GetDotTicks(f.spell, guid))..")"
				else
					if f.spell == 2944 then
						f.datanew.t1 = targets[guid..f.spell][4]
					else
						f.datanew.t1 = dot_damage[f.spell][1].."/"..targets[guid..f.spell][1]..targets[guid..f.spell][4]
					end
				end
			else
				if o.shadow.showticknumber and f.spell ~= 2944 then
					f.datanew.t1 = dot_damage[f.spell][1].."\n"..targets[guid..f.spell][1]..targets[guid..f.spell][4]..gap.."("..select(2, GetDotTicks(f.spell, guid))..")"
				else
					if f.spell == 2944 then
						f.datanew.t1 = targets[guid..f.spell][4]
					else
						f.datanew.t1 = dot_damage[f.spell][1].."\n"..targets[guid..f.spell][1]..targets[guid..f.spell][4]
					end
				end
			end
		else
			f.datanew.color = o.color7
			f.datanew.t1 = 0
			f.datanew.t2 = ""
			f.datanew.tick = 0
			f.timer = 0
			f.datanew.hidecd = true
		end
	end,
	shadoworbs = function(f)
		local power = UnitPower("player", SPELL_POWER_SHADOW_ORBS)
		local color = 1
		if 		power == 3 then color = 1
		elseif 	power == 2 then color = 2
		elseif 	power == 1 then color = 3
		end
		if power == 0 then
			f.datanew.setw = o.bars.w*0.01/3
		else
			f.datanew.setw = o.bars.w*power/3
		end
		f.datanew.t1 = power
		f.datanew.color = o["color"..color]
	end,
	shadowworddeath = function(f)
		local icd = 6
		if not is50300 then icd = 9 end
			
		local name = GetSpellInfo(32379);
		local start, duration, enabled = GetSpellCooldown(name)
		

		if start > 0 and duration > 2 then	

			f.datanew.t1 = "CD"
			f.datanew.timer = duration 
			f.datanew.expires = start + duration
			f.datanew.duration = duration
			f.datanew.setcd = true
			f.datanew.color = o.shadow.color3
			f.datanew.t2 = SecondsRound(whengetorb + icd - GetTime())
			
		--	getorb = false
		elseif getorb and whengetorb then
			f.datanew.t1 = "ICD"
			f.datanew.timer = icd
			f.datanew.expires = whengetorb + icd
			f.datanew.duration = icd

			f.datanew.setcd = true
			f.datanew.color = o.shadow.color2
			
			if GetTime() > (whengetorb + icd) then
				getorb = false
			end
			f.datanew.t2 = SecondsRound(whengetorb + icd - GetTime())
		else
			f.datanew.t1 = ""
			f.datanew.t2 = ""
			f.datanew.hidecd = true
			
			if GetSWDtargetHP() then
				f.datanew.color = o.shadow.color1
			else
				f.datanew.color = o.shadow.color4
			end
			

		--	getorb = false
		end
	end,
	mindflay = function(f)
		
	--	print(f and f.duration, f.iconfile)
		
	--	local mf_icon 			= select(3, GetSpellInfo(15407))
	--	local insanity_icon  	= select(3, GetSpellInfo(129197))
		
		
		
		
		local name, subText, text, texture, startTime, endTime, isTradeSkill, notInterruptible = UnitChannelInfo("player")
		
		if name and ( name == spells.mf or spells.insanity == name ) then 
			
			local duration = (endTime-startTime)*0.001
			local expires = (endTime*0.001)
			local start = startTime*0.001
			local current = expires - GetTime()
			if o.layout == "bars" then
			
				f.datanew.expires = start + duration
				f.datanew.duration = current
				f.datanew.setcd = true
				
				f.datanew.setw = o.bars.w*current/duration
			--	f.datanew.t1 = current
				f.datanew.color = o.color5
				
				f.datanew.tick = 0.5
				f.datanew.t2 = SecondsRound(current)
			else
				f.datanew.t1 = ""
				f.datanew.timer = duration
				f.datanew.expires = expires
				f.datanew.duration = duration
				f.datanew.setcd = true
				f.datanew.color = o.color5
				f.datanew.t2 = SecondsRound(current)
			end
		else
			f.datanew.setw = 0.001
			f.datanew.color = o.color7
		--	f.datanew.t1 = 0
			f.datanew.t2 = ""
			f.datanew.tick = 0
			f.timer = 0
			f.datanew.hidecd = true
			
			
		end
	end,
	
	mindblast = function(f)
		local name = GetSpellInfo(124430)
		local name1 = GetSpellInfo(8092)
		local start, duration, enabled = GetSpellCooldown(name1)
		local glowenable = false
		local diaira = UnitBuff("player", name)
		
		if start > 0 and duration > 6 then 
			
			f.datanew.t1 = "CD"
			f.datanew.timer = duration
			f.datanew.expires = start + duration
			f.datanew.duration = duration
			f.datanew.setcd = true
			f.datanew.color = o.color2
			f.datanew.t2 = SecondsRound(start + duration - GetTime())
		else
			
			f.datanew.t1 = ""
			f.datanew.t2 = ""
			f.datanew.hidecd = true
			f.datanew.color = o.color1
		end
		
		if not glowenable and diaira then		
			ActionButton_ShowOverlayGlow(MindBlastFrame)
			glowenable = true
		else
			ActionButton_HideOverlayGlow(MindBlastFrame)
			glowenable = false
		end
	end,
}

local GetDotDmg = {
	function() end,
	function() end,
	function() 
		local mastery, haste, crit, spd, sorbs = GetMastery(), UnitSpellHaste("player"), GetSpellCritChance(6), GetSpellBonusDamage(6), UnitPower("player", SPELL_POWER_SHADOW_ORBS)
		
		local damage_buffs = GetDmgBuffsUpdate()
		crit_s = ""
		
		if crit >= 100 then
			crit = 100
			crit_s = "c"
		end
		
		damage_bonus 		= (1+crit/100) --*(1+(mastery*1.8)/100)
		tick_every 			= 3/(1+(haste/100))
		
		ticks 				= Round(18/tick_every)
		ticks_1 			= Round(6/tick_every)
		
		duration 			= ticks * tick_every
		damage				= ticks*(663 +spd*0.311)*damage_bonus*damage_buffs -- ticks*(623+spd*0.293)*damage_bonus*GetDmgBuffsUpdate()
		dps					= Round(damage/duration)
		if not dot_damage[589] then	
			dot_damage[589] = {Round(dps/100)/10, tick_every, duration, ticks, crit_s, (663 +spd*0.311),ticks_1 }
		else
			dot_damage[589][1] = Round(dps/100)/10
			dot_damage[589][2] = tick_every
			dot_damage[589][3] = duration
			dot_damage[589][4] = ticks
			dot_damage[589][5] = crit_s
			dot_damage[589][6] = (663 +spd*0.311)
			dot_damage[589][7] = ticks_1
		end
		
		ticks 				= Round(15/tick_every)
		ticks_1 			= Round(1.5/tick_every)
		duration 			= ticks * tick_every
		damage				= ticks*(75+spd*0.415)*damage_bonus*damage_buffs
		dps					= Round(damage/duration)

		if not dot_damage[34914] then	
			dot_damage[34914] = {Round(dps/100)/10, tick_every, duration, ticks, crit_s, (75+spd*0.415),ticks_1 }
		else
			dot_damage[34914][1] = Round(dps/100)/10
			dot_damage[34914][2] = tick_every
			dot_damage[34914][3] = duration
			dot_damage[34914][4] = ticks
			dot_damage[34914][5] = crit_s
			dot_damage[34914][6] = (75+spd*0.415)
			dot_damage[34914][7] = ticks_1
		end
		
		
		tick_every			= 1/(1+(haste/100))
		ticks 				= Round(6/tick_every)
		duration 			= ticks * tick_every
		damage				= ticks*(9+spd*0.131)*sorbs*damage_bonus*damage_buffs
		dps					= Round(damage/duration)
		dot_damage[2944]		= {Round(dps/100)/10, tick_every, duration, ticks, crit_s}
		
		if not dot_damage[2944] then	
			dot_damage[2944] = {Round(dps/100)/10, tick_every, duration, ticks, crit_s }
		else
			dot_damage[2944][1] = Round(dps/100)/10
			dot_damage[2944][2] = tick_every
			dot_damage[2944][3] = duration
			dot_damage[2944][4] = ticks
			dot_damage[2944][5] = crit_s
		end
		
	end,
	function() end,
}

function AffDots:ElvNP()
	local ElvUI_NP_New = ElvUI[1].NamePlates.CreatedPlates
	local ElvUI_NP_Old = ElvUI[1].NamePlates.Handled
	
	local frame, time_left, icon, spell, pandemic, GUID, c
	
	if ElvUI_NP_New then
		for frame, frame_auras in pairs(ElvUI_NP_New) do
			GUID = frame.guid
			
			if GUID then
			
				for id, auraF in pairs(frame_auras.DebuffWidget.icons) do
					icon = auraF.Icon:GetTexture()
					
					if icon then icon = string.lower(icon) end
					if AffDots.tidyspells[icon] then
						spell = AffDots.tidyspells[icon].spell; pandemic = AffDots.tidyspells[icon].pandemic		
						time_left = auraF.TimeLeft:GetText() and tonumber(string.sub(auraF.TimeLeft:GetText(), 11, -3)) or nil
					end
					if not auraF.affdots then
						auraF.Icon:SetDrawLayer("ARTWORK")
						auraF.AffBorder = auraF:CreateTexture(nil, "BORDER")
						auraF.AffBorder:SetDrawLayer("BACKGROUND")
						auraF.AffBorder:SetSize(o.tidyplates.w,o.tidyplates.h)
						auraF.AffBorder:SetPoint("CENTER", auraF, "CENTER",0, 0)
						auraF.affdots = true
					end
					if AffDots.tidyspells[icon] then
						if not auraF.AffBorder:IsShown() then
							auraF.AffBorder:Show()
						end
					else
						if auraF.AffBorder:IsShown() then
							auraF.AffBorder:Hide()
						end
					end
					if spell and time_left then
						c = AffDots:FindColor(GUID,time_left,spell,pandemic)
						auraF.AffBorder:SetTexture(o["color"..c][1],o["color"..c][2],o["color"..c][3],o.tidyplates.transparency)
					else
						auraF.AffBorder:SetTexture(1,0,0,o.tidyplates.transparency)
					end
				end
			end
		end
	elseif 	ElvUI_NP_Old then
		for frame, _ in pairs(ElvUI_NP_Old) do
			frame = _G[frame]:GetChildren()	
			GUID = frame.guid
			
			if GUID then
			
				for id, auraF in pairs(frame.DebuffWidget.icons) do
					icon = auraF.Icon:GetTexture()
					if icon then icon = string.lower(icon) end
					if AffDots.tidyspells[icon] then
						spell = AffDots.tidyspells[icon].spell; pandemic = AffDots.tidyspells[icon].pandemic
						time_left = tonumber(string.sub(auraF.TimeLeft:GetText(), 11, -3))
					end
					if not auraF.affdots then
						auraF.Icon:SetDrawLayer("ARTWORK")
						auraF.AffBorder = auraF:CreateTexture(nil, "BORDER")
						auraF.AffBorder:SetDrawLayer("BACKGROUND")
						auraF.AffBorder:SetSize(o.tidyplates.w,o.tidyplates.h)
						auraF.AffBorder:SetPoint("CENTER", auraF, "CENTER",0, 0)
						auraF.affdots = true
					end
					if AffDots.tidyspells[icon] then
						if not auraF.AffBorder:IsShown() then
							auraF.AffBorder:Show()
						end
					else
						if auraF.AffBorder:IsShown() then
							auraF.AffBorder:Hide()
						end
					end
					if spell and time_left then
						c = AffDots:FindColor(GUID,time_left,spell,pandemic)
						auraF.AffBorder:SetTexture(o["color"..c][1],o["color"..c][2],o["color"..c][3],o.tidyplates.transparency)
					else
						auraF.AffBorder:SetTexture(1,0,0,o.tidyplates.transparency)
					end
				end
			end
		end
	end
end



function AffDots:Tidy()
	local TidyPlates = TidyPlates
	local time_left, icon, spell, pandemic, GUID, c
	for plate in pairs(TidyPlates.NameplatesByVisible) do
		
		local widgets = plate.extended.widgets.DebuffWidget or plate.extended.widgets.WidgetDebuff
		
		if not widgets then return false end

		
		GUID = plate.extended.unit.guid
		if GUID then
			for id,frame in pairs(widgets.AuraIconFrames) do
				icon = frame.Icon:GetTexture()
				if icon then icon = string.lower(icon) end
	
				if AffDots.tidyspells[icon] then
					spell = AffDots.tidyspells[icon].spell; pandemic = AffDots.tidyspells[icon].pandemic
					time_left = tonumber(frame.TimeLeft:GetText())
				end
				if not frame.affdots then
					frame.Icon:SetDrawLayer("ARTWORK")
					frame.AffBorder = frame:CreateTexture(nil, "BORDER")
					frame.AffBorder:SetDrawLayer("BACKGROUND")
					frame.AffBorder:SetSize(o.tidyplates.w,o.tidyplates.h)
					frame.AffBorder:SetPoint("CENTER", frame, "CENTER",0, 0)
					frame.affdots = true
				end
				if AffDots.tidyspells[icon] then
					if not frame.AffBorder:IsShown() then
						frame.AffBorder:Show()
					end
				else
					if frame.AffBorder:IsShown() then
						frame.AffBorder:Hide()
					end
				end
				if spell and time_left then
					c = AffDots:FindColor(GUID,time_left,spell,pandemic)
					frame.AffBorder:SetTexture(o["color"..c][1],o["color"..c][2],o["color"..c][3],o.tidyplates.transparency)
				else
					frame.AffBorder:SetTexture(0,0,0,o.tidyplates.transparency)
				end
			end
		end
	end
end

local function GetDotDur(spellid, destGUID)
	local spellname = swp_vt[spellid]
	
	if not spellname then return end
	
	local unit = "target"
	
	if destGUID == UnitGUID("focus") then
		unit = "focus"
	elseif destGUID == UnitGUID("boss1") then
		unit = "boss1"
	elseif destGUID == UnitGUID("boss2") then
		unit = "boss2"
	elseif destGUID == UnitGUID("boss3") then
		unit = "boss3"
	elseif destGUID == UnitGUID("boss4") then
		unit = "boss4"
	elseif destGUID == UnitGUID("boss5") then
		unit = "boss5"
	end

	local duration =	select(6, UnitDebuff(unit, spellname, nil, "PLAYER")) or 0
	local expiration = 	select(7, UnitDebuff(unit, spellname, nil, "PLAYER")) or GetTime()
			
	local testtime = expiration-duration
	
	return duration, expiration, testtime
end

local lsttick = {
	[589]   = 0,
	[34914] = 0,
}

local defaul_tick = {
	[589] = 6,
	[34919] = 5,
}

local _AffDots_PLAYER_REGEN_ENABLED = AffDots.PLAYER_REGEN_ENABLED
local function ClearDotData()
	wipe(durSaved)
	wipe(saGUID)
	
	collectgarbage("collect")
end	

function AffDots:PLAYER_REGEN_ENABLED()
	_AffDots_PLAYER_REGEN_ENABLED()
	ClearDotData()
end
	
		
local CombatLog = {
	function() end,
	function() end,
	function(_,_,_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_, ...)
	
		if is50300 and event_type == "SPELL_DAMAGE" and saGUID[source_GUID] == me and set2t15 then
			if dest_GUID == UnitGUID("target") or 
				dest_GUID == UnitGUID("focus") or 
				dest_GUID == UnitGUID("boss1") or 
				dest_GUID == UnitGUID("boss2") or 
				dest_GUID == UnitGUID("boss3") or 
				dest_GUID == UnitGUID("boss4") or 
				dest_GUID == UnitGUID("boss5") then
				
				saGUID[source_GUID] = nil
				
				if durSaved[dest_GUID.."589"] and durSaved[dest_GUID.."589"][1] < select(2, GetDotDur(589, dest_GUID)) then 
					durSaved[dest_GUID.."589"][1] = select(2, GetDotDur(589, dest_GUID))
					if GetDotTicks(589, dest_GUID) then
						targets[dest_GUID.."589"] = {dot_damage[589][1],GetTime(),dot_damage[589][2], dot_damage[589][5], dot_damage[589][4], dot_damage[589][6], dot_damage[589][7]}
					end
				end
				if durSaved[dest_GUID.."34914"] and durSaved[dest_GUID.."34914"][1] < select(2, GetDotDur(34914, dest_GUID)) then
					durSaved[dest_GUID.."34914"][1] = select(2, GetDotDur(34914, dest_GUID))
					if GetDotTicks(34914, dest_GUID) then
						targets[dest_GUID.."34914"] = {dot_damage[34914][1],GetTime(),dot_damage[34914][2], dot_damage[34914][5], dot_damage[589][4], dot_damage[589][6], dot_damage[589][7]}
					end
				end
			end
		end
		
		if dest_GUID == me and select(1, ...) == 137590 then
			AffDots:GetDotDmg()
		end
		if source_GUID ~= me then return end
		spell = select(1, ...)
		if event_type == "SPELL_AURA_APPLIED" then
			if spell == 34914 then
					if dest_GUID == UnitGUID("target") or 
						dest_GUID == UnitGUID("focus") or 
						dest_GUID == UnitGUID("boss1") or 
						dest_GUID == UnitGUID("boss2") or 
						dest_GUID == UnitGUID("boss3") or 
						dest_GUID == UnitGUID("boss4") or 
						dest_GUID == UnitGUID("boss5") then
						durSaved[dest_GUID.."34914"] = { select(2, GetDotDur(34914, dest_GUID)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."34914"] = { dot_damage[34914][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				
					local have_uvls	= UnitAura("player",spells.uvls)
					if have_uvls then
						crit_h = "c"
					else
						crit_h = ""
					end
				targets[dest_GUID.."34914"] = {dot_damage[34914][1],GetTime(),dot_damage[34914][2], dot_damage[34914][5], dot_damage[589][4], dot_damage[589][6], dot_damage[589][7]}
				dot_tiks[dest_GUID.."34914"] = dot_damage[34914][4]
		elseif spell == 589 then
					if dest_GUID == UnitGUID("target") or 
						dest_GUID == UnitGUID("focus") or 
						dest_GUID == UnitGUID("boss1") or 
						dest_GUID == UnitGUID("boss2") or 
						dest_GUID == UnitGUID("boss3") or 
						dest_GUID == UnitGUID("boss4") or 
						dest_GUID == UnitGUID("boss5") then
						durSaved[dest_GUID.."589"] = { select(2, GetDotDur(589, dest_GUID)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."589"] = { dot_damage[589][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				targets[dest_GUID.."589"] = {dot_damage[589][1],GetTime(),dot_damage[589][2], dot_damage[589][5], dot_damage[589][4], dot_damage[589][6], dot_damage[589][7]}
				dot_tiks[dest_GUID.."589"] = dot_damage[589][4] +1
			elseif spell == 2944 then
				targets[dest_GUID.."2944"] = {dot_damage[2944][1],GetTime(),dot_damage[2944][2], dot_damage[2944][5]}
			end
		elseif event_type == "SPELL_AURA_REFRESH" then
			
			if spell == 34914 and GetTime() - protect > 0.5 then
					if dest_GUID == UnitGUID("target") or 
						dest_GUID == UnitGUID("focus") or 
						dest_GUID == UnitGUID("boss1") or 
						dest_GUID == UnitGUID("boss2") or 
						dest_GUID == UnitGUID("boss3") or 
						dest_GUID == UnitGUID("boss4") or 
						dest_GUID == UnitGUID("boss5") then
						durSaved[dest_GUID.."34914"] = { select(2, GetDotDur(34914, dest_GUID)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."34914"] = { dot_damage[34914][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				targets[dest_GUID.."34914"] = {dot_damage[34914][1],GetTime(),dot_damage[34914][2], dot_damage[34914][5], dot_damage[589][4], dot_damage[589][6], dot_damage[589][7]}
				dot_tiks[dest_GUID.."34914"] = dot_damage[34914][4]+1
			elseif spell == 589 and GetTime() - protect > 0.5 then
					if dest_GUID == UnitGUID("target") or 
						dest_GUID == UnitGUID("focus") or 
						dest_GUID == UnitGUID("boss1") or 
						dest_GUID == UnitGUID("boss2") or 
						dest_GUID == UnitGUID("boss3") or 
						dest_GUID == UnitGUID("boss4") or 
						dest_GUID == UnitGUID("boss5") then
						durSaved[dest_GUID.."589"] = { select(2, GetDotDur(589, dest_GUID)), GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					else
						durSaved[dest_GUID.."589"] = { dot_damage[589][2] , GetSpellBonusDamage(6), GetDmgBuffsUpdate() }
					end
				targets[dest_GUID.."589"] = {dot_damage[589][1],GetTime(),dot_damage[589][2], dot_damage[589][5], dot_damage[589][4], dot_damage[589][6], dot_damage[589][7]}
				dot_tiks[dest_GUID.."589"] = dot_damage[589][4]+2
			elseif spell == 2944 and GetTime() - protect > 0.5 then
				targets[dest_GUID.."2944"] = {dot_damage[2944][1],GetTime(),dot_damage[2944][2], dot_damage[2944][5]}
			end
		elseif event_type == "SPELL_SUMMON" and is50300 then
			saGUID[dest_GUID] = me
		elseif event_type == "SPELL_DAMAGE" then
			if (spell == 589 or spell == 34914) then
				protect = GetTime()
			elseif ( set2t15 and spell == 148859 and not is50300) then
				if dest_GUID == UnitGUID("target") or 
					dest_GUID == UnitGUID("focus") or 
					dest_GUID == UnitGUID("boss1") or 
					dest_GUID == UnitGUID("boss2") or 
					dest_GUID == UnitGUID("boss3") or 
					dest_GUID == UnitGUID("boss4") or 
					dest_GUID == UnitGUID("boss5") then
					
					if durSaved[dest_GUID.."589"] and durSaved[dest_GUID.."589"][1] < select(2, GetDotDur(589, dest_GUID)) then 
						durSaved[dest_GUID.."589"][1] = select(2, GetDotDur(589, dest_GUID))
						if GetDotTicks(589, dest_GUID) then
							targets[dest_GUID.."589"] = {dot_damage[589][1],GetTime(),dot_damage[589][2], dot_damage[589][5], dot_damage[589][4], dot_damage[589][6], dot_damage[589][7]}
						end
					end
					if durSaved[dest_GUID.."34914"] and durSaved[dest_GUID.."34914"][1] < select(2, GetDotDur(34914, dest_GUID)) then
						durSaved[dest_GUID.."34914"][1] = select(2, GetDotDur(34914, dest_GUID))
						if GetDotTicks(34914, dest_GUID) then
							targets[dest_GUID.."34914"] = {dot_damage[34914][1],GetTime(),dot_damage[34914][2], dot_damage[34914][5], dot_damage[589][4], dot_damage[589][6], dot_damage[589][7]}
						end
					end
				end
			end
		elseif event_type == "SPELL_CAST_SUCCESS" then
			if spell == 32379 or spell == 129176 then
				getorb = true
				whengetorb = GetTime()
			end
		elseif event_type == "SPELL_PERIODIC_DAMAGE" then
			if (spell == 589 or spell == 34914) then
				RemoveDotTic(spell, dest_GUID)
			end
		end
	end,
	function() end,
}

function AffDots:InitSpec()
	AffDots:ReleaseFrames()
	wipe(AffDots.track)
	AffDots.execute_percent = 20
	AffDots:Track(  34914,	  AffDots.Update.dot,             "target",   15,  0, o.shadow.vt,   o.shadow.show_vt)
	AffDots:Track(  589,	  AffDots.Update.dot,             "target",   18,  0, o.shadow.swp,  o.shadow.show_swp)
	AffDots:Track( 2944,	  AffDots.Update.dot,             "target",   6,   0, o.shadow.dp,   o.shadow.show_dp)
	AffDots:Track(95740,      AffDots.Update.shadoworbs,      "target",   3,   0, o.shadow.orbs, o.shadow.show_orbs)
	AffDots:Track(32379,	  AffDots.Update.shadowworddeath, "target",   8,   0, o.shadow.swd,  o.shadow.show_swd)
	AffDots:Track(8092,		  AffDots.Update.mindblast,		  "target",	  8,   0, o.shadow.mb,	 o.shadow.show_mb)
	AffDots:Track(15407	,	  AffDots.Update.mindflay,		  "target",	  3,   0, o.shadow.mf,	 o.shadow.show_mf)
	
	
	if o.focus then
		AffDots:Track(  34914,	  AffDots.Update.dot,  "focus",	  15,  0, o.shadow.vt,   o.shadow.show_vt)
		AffDots:Track(    589,	  AffDots.Update.dot,  "focus",	  18,  0, o.shadow.swp,  o.shadow.show_swp)
		AffDots:Track( 2944,	  AffDots.Update.dot,  "focus",   6,   0, o.shadow.dp,   o.shadow.show_dp)
	end
		
	AffDots.tidyspells = {}
	
	local swp_texture = string.lower("Interface\\Icons\\Spell_Shadow_ShadowWordPain")
	local vt_texture = string.lower("Interface\\Icons\\Spell_Holy_Stoicism")
	
	if o.shadow.show_swp then AffDots.tidyspells[swp_texture] = {spell = 589, pandemic = 0} end
	if o.shadow.show_vt then AffDots.tidyspells[vt_texture] = {spell = 34914, pandemic = 0} end
	
	AffDots:Detect2T15()
	
	AffDots:InitFrames()
	
	if ElvUI then
		ElvAPI = ElvUI[1]:GetModule('ActionBars')
	end

	for k,v in pairs(AffDots.track) do
	
		if ElvAPI then 
			if not AffDots.track[k].f.cd.isRegistered then
				ElvAPI:RegisterCooldown(AffDots.track[k].f.cd)
				AffDots.track[k].f.cd.isRegistered = true
			end
		end
		if AffDots.track[k].spell == 8092 then
			MindBlastFrame = AffDots.track[k].f.icon
		end
	end
end

function AffDots:InitClass()
	AffDots:RegisterEvent("PLAYER_TALENT_UPDATE", "InitClass")
	me = UnitGUID("player")
	o = self.db.profile
	AffDots:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	AffDots:UnregisterEvent("COMBAT_RATING_UPDATE")
	AffDots:UnregisterEvent("SPELL_POWER_CHANGED")
	AffDots:UnregisterEvent("UNIT_STATS")
	AffDots:UnregisterEvent("PLAYER_DAMAGE_DONE_MODS")
	AffDots:UnregisterEvent("PLAYER_REGEN_ENABLED")
	AffDots:UnregisterEvent("PLAYER_REGEN_DISABLED")
	AffDots:UnregisterEvent("PLAYER_FOCUS_CHANGED")
	AffDots:UnregisterEvent("PLAYER_EQUIPMENT_CHANGED")
	AffDots:UnregisterEvent("MODIFIER_STATE_CHANGED")
	AffDotsTarget:SetScript("OnUpdate", nil)
	AffDotsTarget:Hide(); AffDotsFocus:Hide(); AffDotsBurst:Hide()
	spec = GetSpecialization() or ""
	
	--if o and o.shadow then		
		--	o.shadow.enabled = o.shadow.enabled   or true
		--	o.shadow.saext	 = o.shadow.saext     or true
			
		--	o.shadow.show_swp = o.shadow.show_swp or true
		--	o.shadow.show_vt  = o.shadow.show_vt  or true
		--	o.shadow.show_dp  = o.shadow.show_dp  or false
		--	o.shadow.show_orbs = o.shadow.show_orbs or false
		--	o.shadow.debug 	  = false
		--	o.shadow.uvls 	  = false
			o.shadow 		  = o.shadow 		  or { }
			o.shadow.vt		  = o.shadow.vt		  or 0
			o.shadow.swp	  = o.shadow.swp      or 1
			o.shadow.dp		  = o.shadow.dp		  or 2
			o.shadow.orbs     = o.shadow.orbs     or 3
			o.shadow.swd      = o.shadow.swd      or 4
			o.shadow.mb		  = o.shadow.mb       or 5
			o.shadow.mf		  = o.shadow.mf       or 6
			o.shadow.gap	  = o.shadow.gap      or false
			o.shadow.color1   = o.shadow.color1	  or {0,0.5,0}		--better
			o.shadow.color2   = o.shadow.color2   or {0.5,0.5,0}		--same
			o.shadow.color3	  = o.shadow.color3   or {0.5,0,0}		--worse
			o.shadow.color4	  = o.shadow.color4   or {0,0,0}			--no dot on target
	--	end
		
	if (spec == 3 and self.db.profile.shadow.enabled ) then
	
		AffDots.GetDotDmg = GetDotDmg[spec]
		AffDots.CombatLog = CombatLog[spec]
		AffDots:GetDotDmg()
		AffDots:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")
		AffDots:RegisterEvent("COMBAT_RATING_UPDATE", "GetDotDmg")
		AffDots:RegisterEvent("SPELL_POWER_CHANGED", "GetDotDmg")
		AffDots:RegisterEvent("UNIT_STATS", "GetDotDmg")
		AffDots:RegisterEvent("PLAYER_DAMAGE_DONE_MODS", "GetDotDmg")
		AffDots:RegisterEvent("UNIT_SPELL_HASTE", "GetDotDmg")
		AffDots:RegisterEvent("PLAYER_REGEN_ENABLED")
		AffDots:RegisterEvent("PLAYER_REGEN_DISABLED")
		AffDots:RegisterEvent("PLAYER_FOCUS_CHANGED")
		AffDots:RegisterEvent("MODIFIER_STATE_CHANGED")
		AffDots:RegisterEvent("PLAYER_EQUIPMENT_CHANGED", "Detect2T15")
		AffDotsTarget:SetScript("OnUpdate", onUpdate)
		AffDots:InitSpec()
	end
end

AffDots.InitializeClass = AffDots.InitClass


function AffDots:GetSpecOptions(spec)
	if spec == "PRIEST3" then
		self.options.args.spec.name = L["Shadow"]
		self.options.args.spec.args = {
		--[[	vtswp = {
				order = 1,name = L["Change SWP and VT postition"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.swpvt = not o.shadow.swpvt; AffDots:InitSpec() end,
				get = function(info) return self.db.profile.shadow.swpvt end
			},	]]	
			shadowspec = {
				order = 1,name = L["Enable"],type = "toggle",
				set = function(info,val) o.shadow.enabled = not o.shadow.enabled; AffDots:InitClass() end,
				get = function() return o.shadow.enabled end
			},
			
		--[[	shadowspecdebuf = {
				order = 3,name = L["Enable Debug"],type = "toggle",
				set = function(info,val) o.shadow.debug = not o.shadow.debug; AffDots:InitClass() end,
				get = function() return o.shadow.debug end
			},]]
			ticknumber = {
				order = 2,name = L["Show normal dot ticks"],type = "toggle",
				set = function(info,val) o.shadow.showticknumber = not o.shadow.showticknumber; AffDots:InitClass() end,
				get = function() return o.shadow.showticknumber end			
			},
			gap = { --o.shadow.gap
				order = 2,name = L["Dot tick count from new line"],type = "toggle",
				set = function(info,val) o.shadow.gap = not o.shadow.gap; AffDots:InitClass() end,
				get = function() return o.shadow.gap end					
			},
			help_dots = {
				order = 3,name = "Floating DoT threshold" ,type = "toggle",
				set = function(info,val) o.shadow.help_dots = not o.shadow.help_dots; AffDots:InitClass() end,
				get = function() return o.shadow.help_dots end			
			},
		--[[	saextend = {
				order = 2,name = L["Turn Off 2p15"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.saext = not o.shadow.saext; AffDots:InitSpec() end,
				get = function(info) return o.shadow.saext end
			},]]
		--[[	fsaextend = {
				order = 2,name = L["Update all scales when exteded (for 5.2)"],type = "toggle",width = "full",
				set = function(info,val) o.shadow.fsaext = not o.shadow.fsaext; AffDots:InitSpec() end,
				get = function(info) return o.shadow.fsaext end
			},]]
			show_swp = {
				order = 2,name = L["Show Shadow Word:Pain"],type = "toggle",
				set = function(info,val) o.shadow.show_swp = not o.shadow.show_swp; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_swp end
			},
			show_vt = {
				order = 2,name = L["Show Vampiric Touch"],type = "toggle",
				set = function(info,val) o.shadow.show_vt = not o.shadow.show_vt; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_vt end
			},
			show_dp = {
				order = 3,name = L["Show Devouring Plague"],type = "toggle",
				set = function(info,val) o.shadow.show_dp = not o.shadow.show_dp; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_dp end
			},
			show_mb = {
				order = 3,name = L["Show Mind Blast"],type = "toggle",
				set = function(info,val) o.shadow.show_mb = not o.shadow.show_mb; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_mb end
			},
			show_orbs = {
				order = 4,name = L["Show Shadow Orbs"],type = "toggle",
				set = function(info,val) o.shadow.show_orbs = not o.shadow.show_orbs; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_orbs end
			},
			show_mf = {
				order = 5,name = L["Show Mind Flay"],type = "toggle",
				set = function(info,val) o.shadow.show_mf = not o.shadow.show_mf; AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_mf end
			},
			desc = {
				order = 9,name = L["Order:"],type = "description",fontSize="medium"
			},
			vt = {
				order = 10,name = L["VT"],type = "range",
				min = 1,max = 7,step = 1,softMin = 1,softMax=7,
				set = function(info,val) o.shadow.vt = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.vt + 1 end
			},
			swp = {
				order = 11,name = L["SWP"],type = "range",
				min = 1,max = 7,step = 1,softMin = 1,softMax=7,
				set = function(info,val) o.shadow.swp = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.swp + 1 end
			},
			dp = {
				order = 12,name = L["DP"],type = "range",
				min = 1,max = 7,step = 1,softMin = 1,softMax=7,
				set = function(info,val) o.shadow.dp = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.dp + 1 end
			},
			mb = {
				order = 13,name = L["Mind Blast"],type = "range",
				min = 1,max = 7,step = 1,softMin = 1,softMax=7,
				set = function(info,val) o.shadow.mb = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.mb + 1 end
			},
			mf = {
				order = 14,name = L["Mind Flay"],type = "range",
				min = 1,max = 7,step = 1,softMin = 1,softMax=7,
				set = function(info,val) o.shadow.mf = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.mf + 1 end
			},
			orbs = {
				order = 14,name = L["ORBS"],type = "range",
				min = 1,max = 7,step = 1,softMin = 1,softMax=7,
				set = function(info,val) o.shadow.orbs = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.orbs + 1 end
			},
		}
		
		-- Remove ICD
			self.options.args.spec.args.swd = {
				order = 15,name = L["SWD"],type = "range",
				min = 1,max = 7,step = 1,softMin = 1,softMax=7,
				set = function(info,val) o.shadow.swd = val - 1; AffDots:InitSpec() end,
				get = function(info) return o.shadow.swd + 1 end
			}
			self.options.args.spec.args.show_swd = {
				order = 4,name = L["Show Shadow Word:Death"],type = "toggle",
				set = function(info,val)o.shadow.show_swd = not o.shadow.show_swd;	AffDots:InitSpec() end,
				get = function(info) return o.shadow.show_swd end
			}		
			self.options.args.spec.args.desc2 = {
				order = 16,name = L["Colors for Shadow Word:Death"],type = "description",fontSize="medium",width="full",
			}
			self.options.args.spec.args.color1 = {
				order = 17,name = L["Can be used"],type = "color",
				set = function(info,r,g,b) self.db.profile.shadow.color1={r,g,b} end,
				get = function(info) return self.db.profile.shadow.color1[1],self.db.profile.shadow.color1[2],self.db.profile.shadow.color1[3],1 end
			}
			self.options.args.spec.args.color2 = {
				order = 18,name = L["ICD"],type = "color",
				set = function(info,r,g,b) self.db.profile.shadow.color2={r,g,b} end,
				get = function(info) return self.db.profile.shadow.color2[1],self.db.profile.shadow.color2[2],self.db.profile.shadow.color2[3],1 end
			}
			self.options.args.spec.args.color3 = {
				order = 19,name = L["CD"],type = "color",
				set = function(info,r,g,b) self.db.profile.shadow.color3={r,g,b} end,
				get = function(info) return self.db.profile.shadow.color3[1],self.db.profile.shadow.color3[2],self.db.profile.shadow.color3[3],1 end
			}
			self.options.args.tidy_plates.name = "NamePlates"
			self.options.args.tidy_plates.args.desc.name = L["shadowdesc"]
			
			self.options.args.tidy_plates.args.elvnp = { --o.shadow.elvui
				order = 2,name = L["Integrate dot colors in ElvUI"],type = "toggle", width = "full",
				set = function(info,val) self.db.profile.elvui = not self.db.profile.elvui; AffDots:InitClass() end,
				get = function() return self.db.profile.elvui end
			}
			
			self.options.args.colors.args={
					color1 = {
						order = 1,width = "full",name = L["Current stats are better"] ,type = "color",
						set = function(info,r,g,b) self.db.profile.color1={r,g,b}; self:SaveColors() end,
						get = function(info) return self.db.profile.color1[1],self.db.profile.color1[2],self.db.profile.color1[3],1 end
					},
					color2 = {
						order = 2,width = "full",name = L["Current stats are same"],type = "color",
						set = function(info,r,g,b) self.db.profile.color2={r,g,b}; self:SaveColors()  end,
						get = function(info) return self.db.profile.color2[1],self.db.profile.color2[2],self.db.profile.color2[3],1 end
					},
					color3 = {
						order = 3,width = "full",name = L["Current stats are worse"].." not used",type = "color",
						set = function(info,r,g,b) self.db.profile.color3={r,g,b}; self:SaveColors()  end,
						get = function(info) return self.db.profile.color3[1],self.db.profile.color3[2],self.db.profile.color3[3],1 end
					},
					color4 = {
						order = 4,width = "full",name = L["Current stats are better, but not optimal for update. Used by floating threshold"],type = "color",
						set = function(info,r,g,b) self.db.profile.color4={r,g,b}; self:SaveColors()  end,
						get = function(info) return self.db.profile.color4[1],self.db.profile.color4[2],self.db.profile.color4[3],1 end
					},
					color5 = {
						order = 5,width = "full",name = L["Mind Flay Bar color"],type = "color",
						set = function(info,r,g,b) self.db.profile.color5={r,g,b}; self:SaveColors()  end,
						get = function(info) return self.db.profile.color5[1],self.db.profile.color5[2],self.db.profile.color5[3],1 end
					},
					color6 = {
						order = 6,width = "full",name = L["Current stats are worse"].." not used",type = "color",
						set = function(info,r,g,b) self.db.profile.color6={r,g,b}; self:SaveColors()  end,
						get = function(info) return self.db.profile.color6[1],self.db.profile.color6[2],self.db.profile.color6[3],1 end
					},
					color7 = {
						order = 7,width = "full",name = L["No dot on target"],type = "color",
						set = function(info,r,g,b) self.db.profile.color7={r,g,b}; self:SaveColors()  end,
						get = function(info) return self.db.profile.color7[1],self.db.profile.color7[2],self.db.profile.color7[3],1 end
					},
					color9 = {
						order = 8,width = "full",name = L["CoE/Hp/Haunt color"],type = "color",
						set = function(info,r,g,b) self.db.profile.color9={r,g,b}; self:SaveColors()  end,
						get = function(info) return self.db.profile.color9[1],self.db.profile.color9[2],self.db.profile.color9[3],1 end
					},
					text_color = {
						order = 9,width = "full",name = L["Text color"],type = "color",
						set = function(info,r,g,b) self.db.profile.color11={r,g,b} end,
						get = function(info) return self.db.profile.color11[1],self.db.profile.color11[2],self.db.profile.color11[3],1 end
					},
					color_switch = {
						order = 10,name = L["Color switch"],type = "range",
						desc = L["Switch color only if current stats are at least x% better"],
						min = 0,max = 40,step = 1,softMin = 0,softMax=40,
						set = function(info,val) self.db.profile.color_switch = 1+val/100 end,
						get = function(info) return (self.db.profile.color_switch-1)*100 end
					},
					transparency = {
						order = 11,name = L["Transparency"],type = "range",
						min = 0,max = 1,step = 0.1,softMin = 0,softMax=1,
						set = function(info,val) self.db.profile.transparency = val; AffDots:InitFrames() end,
						get = function(info) return self.db.profile.transparency end
					},
			}
	else
		self.options.args.spec.name = "Specialization"
		self.options.args.spec.args = {
			spacer1 = {
				order = 1,type = "description",name="Specialization not supported, AffDots deactivated", width="full",
			},
		}
	end
end